#line 1 "H:/bad/so.c"
#line 1 "h:/bad/ps2_mouse.c"





sbit PS2_Data_Mouse at RC0_bit;
sbit PS2_Clock_Mouse at RC1_bit;
sbit PS2_Data_Direction_Mouse at TRISC0_bit;
sbit PS2_Clock_Direction_Mouse at TRISC1_bit;









typedef unsigned char byte;

typedef struct
{
 byte Keys;
 int DeltaX;
 int DeltaY;
 int DeltaZ;
} TMouseData;

unsigned int PS2_Mouse_TimeOut;
unsigned int PS2_Mouse_TimeOut2;
byte PS2_Mouse_TimeOutError;
byte PS2_Mouse_ScrollWheel;

byte PS2_Mouse_Init();




byte PS2_Mouse_ReadData(TMouseData *MouseData);






void PS2_Mouse_Write(byte *Values, byte Count);




void PS2_Mouse_Write_Read(byte *Command, byte CountWrite, byte *Reply, byte CountRead);


byte PS2_Mouse_Reset();




byte PS2_Mouse_ScrollWheel_Present();



byte WaitForClockLow()
{
 unsigned int TmpW;
 TmpW = 0;
 do
 {
 TmpW++;
 } while ((PS2_Clock_Mouse != 0) && (TmpW < PS2_Mouse_TimeOut));
 return (PS2_Clock_Mouse == 0);
}

byte WaitForClockHigh()
{
 unsigned int TmpW;
 TmpW = 0;
 do
 {
 TmpW++;
 } while ((PS2_Clock_Mouse != 1) && (TmpW < PS2_Mouse_TimeOut));
 return (PS2_Clock_Mouse == 1);
}

byte WaitForInitialClockLow()
{
 unsigned int TmpW;
 TmpW = 0;
 do
 {
 TmpW++;
 } while ((PS2_Clock_Mouse != 0) && (TmpW < PS2_Mouse_TimeOut2));
 return (PS2_Clock_Mouse == 0);
}

byte PS2_Mouse_Get_Byte()
{
 byte I, Tmp;

 PS2_Mouse_TimeOutError =  0 ;
 if (!WaitForInitialClockLow())
 {
 PS2_Mouse_TimeOutError =  1 ;
 return 0;
 }

 I = 0;
 Tmp = 0;
 while (I < 11)
 {
 if (!WaitForClockLow())
 {
 PS2_Mouse_TimeOutError =  1 ;
 return 0;
 }
 Delay_us(10);
 if ((I > 0) && (I < 9))
 {
 Tmp >>= 1;
 Tmp.B7 = PS2_Data_Mouse;
 }
 if (!WaitForClockHigh())
 {
 PS2_Mouse_TimeOutError =  1 ;
 return 0;
 }
 I++;
 }
 return Tmp;
}

byte PS2_Mouse_SelftestResult()
{
 byte Result =  0 ;
 byte Tmp;
 unsigned int Cnt;


 Cnt = 0;
 do
 {
 PS2_Clock_Mouse = 1;
 PS2_Clock_Direction_Mouse = 1;
 Delay_us(2);

 Tmp = PS2_Mouse_Get_Byte();

 PS2_Clock_Mouse = 0;
 PS2_Clock_Direction_Mouse = 0;
 Delay_us(2);

 if (!PS2_Mouse_TimeOutError)
 {
 if (Tmp == 0xAA)
 Result =  1 ;
 else if (Tmp == 0xFC)
 return  0 ;
 }

 Cnt++;
 } while ((Result !=  1 ) && (Cnt < 66));

 do
 {
 PS2_Clock_Mouse = 1;
 PS2_Clock_Direction_Mouse = 1;
 Delay_us(2);
 Tmp = PS2_Mouse_Get_Byte();
 } while (!PS2_Mouse_TimeOutError);

 PS2_Clock_Mouse = 0;
 PS2_Clock_Direction_Mouse = 0;
 Delay_us(2);
 return Result;
}

byte PS2_Mouse_Enable_ScrollWheel()
{
 byte Cmd[7];
 byte Tmp;

 Cmd[0] = 0xF3;
 Cmd[1] = 200;
 Cmd[2] = 0xF3;
 Cmd[3] = 100;
 Cmd[4] = 0xF3;
 Cmd[5] = 80;
 Cmd[6] = 0xF2;
 PS2_Mouse_Write(Cmd, 7);

 PS2_Clock_Mouse = 1;
 PS2_Clock_Direction_Mouse = 1;
 Delay_us(2);

 Tmp = PS2_Mouse_Get_Byte();

 PS2_Clock_Mouse = 0;
 PS2_Clock_Direction_Mouse = 0;
 Delay_us(2);

 return ((!PS2_Mouse_TimeOutError) && (Tmp == 3));
}

byte PS2_Mouse_ScrollWheel_Present()
{
 return PS2_Mouse_ScrollWheel;
}

byte PS2_Mouse_Reset()
{
 byte Arr;
 byte Result;

 PS2_Mouse_TimeOutError =  0 ;
 PS2_Mouse_ScrollWheel =  0 ;
 Result =  0 ;

 Arr = 0xFF;
 PS2_Mouse_Write(&Arr, 1);

 Result = PS2_Mouse_SelftestResult();

 PS2_Mouse_ScrollWheel = PS2_Mouse_Enable_ScrollWheel();

 Arr = 0xF4;
 PS2_Mouse_Write(&Arr, 1);

 PS2_Clock_Mouse = 0;
 PS2_Clock_Direction_Mouse = 0;
 Delay_us(2);
 return Result;
}

byte PS2_Mouse_Init()
{
 PS2_Mouse_TimeOutError =  0 ;
 PS2_Mouse_ScrollWheel =  0 ;

 PS2_Mouse_TimeOut = (unsigned int)(20 * Clock_MHz());
 PS2_Mouse_TimeOut2 = 30 * PS2_Mouse_TimeOut;

 PS2_Clock_Mouse = 0;
 PS2_Clock_Direction_Mouse = 0;
 Delay_us(2);

 PS2_Data_Mouse = 1;
 PS2_Data_Direction_Mouse = 1;
 Delay_us(2);

 PS2_Mouse_SelftestResult();
 return PS2_Mouse_Reset();
}

byte PS2_Mouse_ReadData(TMouseData *MouseData)
{
 byte Index, Tmp;
 byte TmpCodes[4] = {0,0,0,0};
 byte MaxCount;

 if (PS2_Mouse_ScrollWheel)
 MaxCount = 4;
 else
 MaxCount = 3;

 PS2_Mouse_TimeOutError =  0 ;

 PS2_Clock_Mouse = 1;
 PS2_Clock_Direction_Mouse = 1;
 Delay_us(2);
#line 283 "h:/bad/ps2_mouse.c"
 Index = 0;
 do
 {
 Tmp = PS2_Mouse_Get_Byte();
 if (PS2_Mouse_TimeOutError)
 {
 PS2_Clock_Mouse = 0;
 PS2_Clock_Direction_Mouse = 0;
 Delay_us(2);
 return 0;
 }
 TmpCodes[Index] = Tmp;
 Index++;
 }
 while (Index != MaxCount);

 PS2_Clock_Mouse = 0;
 PS2_Clock_Direction_Mouse = 0;
 Delay_us(2);

 MouseData->Keys = TmpCodes[0] & 7;

 if (TmpCodes[0].B4 == 1)
 MouseData->DeltaX = TmpCodes[1] | 0xFF00;
 else
 MouseData->DeltaX = TmpCodes[1];

 if (TmpCodes[0].B5 == 1)
 MouseData->DeltaY = TmpCodes[2] | 0xFF00;
 else
 MouseData->DeltaY = TmpCodes[2];

 if (TmpCodes[3].B7 == 1)
 MouseData->DeltaZ = TmpCodes[3] | 0xFF00;
 else
 MouseData->DeltaZ = TmpCodes[3];

 return  1 ;
}

byte WaitForClockHighThenLow()
{
 unsigned int TmpW;
 TmpW = 0;
 do
 {
 TmpW++;
 }
 while ((PS2_Clock_Mouse != 1) && (TmpW < PS2_Mouse_TimeOut));

 if (PS2_Clock_Mouse != 1)
 return  0 ;

 TmpW = 0;
 do
 {
 TmpW++;
 }
 while ((PS2_Clock_Mouse != 0) && (TmpW < PS2_Mouse_TimeOut));

 return (PS2_Clock_Mouse == 0);
}

byte WaitForDataLowThenHigh()
{
 unsigned int TmpW;
 TmpW = 0;
 do
 {
 TmpW++;
 }
 while ((PS2_Data_Mouse != 0) && (TmpW < PS2_Mouse_TimeOut));

 if (PS2_Data_Mouse != 0)
 return  0 ;

 TmpW = 0;
 do
 {
 TmpW++;
 }
 while ((PS2_Data_Mouse != 1) && (TmpW < PS2_Mouse_TimeOut));

 return (PS2_Data_Mouse == 1);
}


void PS2_Mouse_Write_Byte(byte Value)
{
 byte Parity, I;
 PS2_Mouse_TimeOutError =  0 ;


 Parity = 0;
 for (I = 1; I; I<<=1)
 if (!(Value & I))
 Parity++;
 if (Parity.B0 == 1)
 Parity = 0;
 else
 Parity = 1;


 PS2_Clock_Mouse = 0;
 PS2_Clock_Direction_Mouse = 0;
 Delay_us(200);
 PS2_Data_Mouse = 0;
 PS2_Data_Direction_Mouse = 0;
 Delay_us(2);
 PS2_Clock_Direction_Mouse = 1;
 PS2_Clock_Mouse = 1;
 Delay_us(2);

 if (!WaitForInitialClockLow())
 {
 PS2_Mouse_TimeOutError =  1 ;
 goto ExitWriteByte;
 }


 for (I = 0; I <= 8; I++)
 {
 if (I < 8)
 {
 PS2_Data_Mouse = Value.B0;
 Value >>= 1;
 }
 else
 PS2_Data_Mouse = Parity;

 if (!WaitForClockHighThenLow())
 {
 PS2_Mouse_TimeOutError =  1 ;
 goto ExitWriteByte;
 }
 }

 PS2_Data_Mouse = 1;
 PS2_Data_Direction_Mouse = 1;

 if (!WaitForClockHighThenLow())
 {
 PS2_Mouse_TimeOutError =  1 ;
 goto ExitWriteByte;
 }

 if (!WaitForDataLowThenHigh())
 {
 PS2_Mouse_TimeOutError =  1 ;
 goto ExitWriteByte;
 }

 ExitWriteByte:

 PS2_Data_Direction_Mouse = 1;
 PS2_Data_Mouse = 1;
 PS2_Clock_Direction_Mouse = 1;
 PS2_Clock_Mouse = 1;
}

void PS2_Mouse_Write(byte *Values, byte Count)
{
 byte Index, Reply;
 Index = 0;
 while (Count > 0)
 {
 PS2_Mouse_Write_Byte(Values[Index]);
 if (PS2_Mouse_TimeOutError)
 break;

 Reply = PS2_Mouse_Get_Byte();
 if (PS2_Mouse_TimeOutError)
 break;

 Index++;
 Count--;
 }

 PS2_Clock_Mouse = 0;
 PS2_Clock_Direction_Mouse = 0;
 Delay_us(2);
 PS2_Data_Direction_Mouse = 1;
 PS2_Data_Mouse = 1;
 Delay_us(2);
}

void PS2_Mouse_Write_Read(byte *Command, byte CountWrite, byte *Reply, byte CountRead)
{
 byte I;
 PS2_Mouse_Write(Command, CountWrite);
 if (CountRead > 0)
 {
 I = 0;
 PS2_Clock_Mouse = 1;
 PS2_Clock_Direction_Mouse = 1;
 Delay_us(2);
 while (I < CountRead)
 {
 Reply[I] = PS2_Mouse_Get_Byte();
 I++;
 }
 PS2_Clock_Mouse = 0;
 PS2_Clock_Direction_Mouse = 0;
 Delay_us(2);
 }
}
#line 17 "H:/bad/so.c"
void main()
{
 TMouseData MouseData;
 byte Cmd;
 byte Reply[3];
 signed int X = 8;
 signed int Y = 8;
 unsigned int Z = 0;

 ANSEL = 0;
 ANSELH = 0;
 C1ON_bit = 0;
 C2ON_bit = 0;

 Delay_ms(100);
 trisb=0;
 portb=0;


 if (!PS2_Mouse_Init())
 {

 }
 else
 {

 Cmd = 0xE9;
 PS2_Mouse_Write_Read(&Cmd, 1, Reply, 3);
 rb0_bit = 1 ;
 rb1_bit = 1 ;
 rb2_bit = 1 ;
 rb3_bit = 1 ;
 delay_ms(500);
 portb=0;
 while ( 1 )
 {

 if (PS2_Mouse_ReadData(&MouseData))
 {
 rb4_bit = MouseData.Keys.B0 ;

 rb5_bit = MouseData.Keys.B1 ;

 X += MouseData.DeltaX;
 X = X%100;
 if(X > 60){
 rb2_bit=0;
 rb3_bit = 1 ;
 }
 else if(X < -60){
 rb3_bit=0;
 rb2_bit = 1 ;
 }



 Y += MouseData.DeltaY;
 Y = Y % 100;
 if(Y > 60){
 rb0_bit=0;
 rb1_bit = 1 ;
 }
 else if(Y < -60){
 rb1_bit=0;
 rb0_bit = 1 ;
 }

 }
 Delay_ms(10);
 rb0_bit=0;
 rb1_bit=0;
 rb2_bit=0;
 rb3_bit=0;
 }
 }
}
